Wt: Wt::Auth::FacebookService Class Reference

Wt 3.3.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions
Wt::Auth::FacebookService Class Reference
Authentication module (Wt::Auth)

OAuth service for Facebook as third-party authenticator. More...

Inheritance diagram for Wt::Auth::FacebookService:
[legend]

List of all members.

## Public Member Functions
| FacebookService (const AuthService &baseAuthService)
| Constructor.
virtual std::string | name () const
| Returns the provider name.
virtual WString | description () const
| Returns the provider description.
virtual int | popupWidth () const
| Returns the desired width for the popup window.
virtual int | popupHeight () const
| Returns the desired height for the popup window.
virtual std::string | authenticationScope () const
| Returns the scope needed for authentication.
virtual std::string | redirectEndpoint () const
| Returns the redirection endpoint URL.
virtual std::string | redirectEndpointPath () const
| Returns the deployment path of the redirection endpoint.
virtual std::string | authorizationEndpoint () const
| Returns the authorization endpoint URL.
virtual std::string | tokenEndpoint () const
| Returns the token endpoint URL.
virtual std::string | clientId () const
| Returns the client ID.
virtual std::string | clientSecret () const
| Returns the client secret.
virtual Http::Method | tokenRequestMethod () const
| Returns the HTTP method used for the token request.
virtual OAuthProcess * | createProcess (const std::string &scope) const
| Creates a new authorizaiton process.
## Static Public Member Functions
static bool | configured ()
| Checks whether a FacebookAuth service is properly configured.

## Detailed Description

OAuth service for Facebook as third-party authenticator.

The configuration of the service is done using properties, whose values need to match the values configured at Facebook.

- `facebook-oauth2-redirect-endpoint`: the URL of the local redirect endpoint, to which the Facebook OAuth service redirects the user after authentication. See also redirectEndpoint()
- `facebook-oauth2-redirect-endpoint-path`: optionally, the deployment path that corresponds to the redirect endpoint. See also redirectEndpointPath()
- `facebook-oauth2-app-id`: The application ID
- `facebook-oauth2-app-secret`: The application secret.

For example:

     <properties>
       <property name="facebook-oauth2-redirect-endpoint">
         http://localhost:8080/oauth2callback
       </property>
       <property name="facebook-oauth2-app-id">
         1234567890123456
       </property>
       <property name="facebook-oauth2-app-secret">
         a3cf1630b1ae415c7260d849efdf444d
       </property>
     </properties>

Like all service classes, this class holds only configuration state. Thus, once configured, it can be safely shared between multiple sessions since its state (the configuration) is read-only. A "const FacebookService" object is thus thread-safe.

See also:
  http://developers.facebook.com/docs/authentication/

## Member Function Documentation

std::string Wt::Auth::FacebookService::authenticationScope | ( |  | ) | const`[virtual]`

Returns the scope needed for authentication.

This returns the scope that is needed (and sufficient) for obtaining identity information, and thus to authenticate the user.

See also:
  OAuthProcess::getIdentity(), OAuthProcess::startAuthenticate()

Implements Wt::Auth::OAuthService.

std::string Wt::Auth::FacebookService::authorizationEndpoint | ( |  | ) | const`[virtual]`

Returns the authorization endpoint URL.

This is a remote URL which hosts the OAuth authorization user interface. This URL is loaded in the popup window at the start of an authorization process.

Implements Wt::Auth::OAuthService.

std::string Wt::Auth::FacebookService::clientId | ( |  | ) | const`[virtual]`

Returns the client ID.

This is the identification for this web application with the OAuth authorization server.

Implements Wt::Auth::OAuthService.

std::string Wt::Auth::FacebookService::clientSecret | ( |  | ) | const`[virtual]`

Returns the client secret.

This is the secret credentials for this web application with the OAuth authorization server.

Implements Wt::Auth::OAuthService.

bool Wt::Auth::FacebookService::configured | ( |  | ) | `[static]`

Checks whether a FacebookAuth service is properly configured.

This returns `true` if a value is found for the three configuration properties.

OAuthProcess * Wt::Auth::FacebookService::createProcess | ( | const std::string & | scope | ) | const`[virtual]`

Creates a new authorizaiton process.

This creates a new authorization process for the indicated scope. Valid names for the scope are service provider dependent.

See also:
  authenticationScope()

Implements Wt::Auth::OAuthService.

WString Wt::Auth::FacebookService::description | ( |  | ) | const`[virtual]`

Returns the provider description.

This returns a description useful for e.g. tool tips on a login icon.

See also:
  name()

Implements Wt::Auth::OAuthService.

std::string Wt::Auth::FacebookService::name | ( |  | ) | const`[virtual]`

Returns the provider name.

This is a short identifier.

See also:
  description()

Implements Wt::Auth::OAuthService.

int Wt::Auth::FacebookService::popupHeight | ( |  | ) | const`[virtual]`

Returns the desired height for the popup window.

See also:
  popupWidth()

Implements Wt::Auth::OAuthService.

int Wt::Auth::FacebookService::popupWidth | ( |  | ) | const`[virtual]`

Returns the desired width for the popup window.

See also:
  popupHeight()

Implements Wt::Auth::OAuthService.

std::string Wt::Auth::FacebookService::redirectEndpoint | ( |  | ) | const`[virtual]`

Returns the redirection endpoint URL.

This is the local URL to which the browser is redirect from the service provider, after the authorization process. You need to configure this URL with the third party authentication service.

A static resource will be deployed at this URL.

See also:
  WServer::addResource()

Implements Wt::Auth::OAuthService.

std::string Wt::Auth::FacebookService::redirectEndpointPath | ( |  | ) | const`[virtual]`

Returns the deployment path of the redirection endpoint.

This returns the path at which the static resource is deployed that corresponds to the redirectEndpoint().

The default implementation will derive this path from the redirectEndpoint() URL.

Reimplemented from Wt::Auth::OAuthService.

std::string Wt::Auth::FacebookService::tokenEndpoint | ( |  | ) | const`[virtual]`

Returns the token endpoint URL.

This is a remote URL which hosts a web-service that generates access tokens.

Implements Wt::Auth::OAuthService.

Http::Method Wt::Auth::FacebookService::tokenRequestMethod | ( |  | ) | const`[virtual]`

Returns the HTTP method used for the token request.

While the current OAuth 2.0 draft mandates the use of POST, some implementations (like Facebook) use URL-encoding and a GET request.

The default implementation returns Http::Post (corresponding to the current draft).

Reimplemented from Wt::Auth::OAuthService.

All Classes Namespaces Functions Variables Typedefs Enumerations Enumerator